var _ = require('underscore');

/**
 * Medios
 */
function VocMedio(options) {
    var defaultOptions = {
        default: false,
        localHeadersPath: 'web/' + options.id + '/cabeceras/',
        remoteHeadersPath: '/' + options.id + '/2015/movil/'
    };

    this.id = options.id;
    this.name = options.name;
    this.options = _.extend(defaultOptions, options.options||{});
}

VocMedio.prototype.isDefault = function () {
    return this.options.default;
};

var VocMedios = function() {
    var medios = [
        new Medio('abc', 'ABC', {
            default: true,
            remoteHeadersPath: '/abc/2015/movil/',
            ftp: {
                des:  {host: '10.200.30.1',            user: 'ftpdenabcweb', pass: '@_x1=t@pMTd', remotePath: '/'},
                pre:  {host: '10.200.22.1',            user: 'ftppenabcweb', remotePath: '/'},
                prod: {host: 'ftp.abc.srv.vocento.in', user: 'ftpnabcweb', remotePath: '/'}
            }
        }),
        new Medio('abcsevilla', 'ABC Sevilla', {
            default: true,
            remoteHeadersPath: '/sevilla/2015/movil/',
            ftp: {
                des:  {host: '10.200.30.1',            user: 'ftpdenabcweb', pass: '@_x1=t@pMTd', remotePath: '/'},
                pre:  {host: '10.200.22.1',            user: 'ftppenabcweb', remotePath: '/'},
                prod: {host: 'ftp.abc.srv.vocento.in', user: 'ftpnabcweb', remotePath: '/'}
            }
        }),
        new Medio('lavozdigital', 'La Voz Digital', {
            default: true,
            remoteHeadersPath: '/lavozdigital/2015/movil/',
            ftp: {
                des:  {host: '10.200.30.1',            user: 'ftpdenabcweb', pass: '@_x1=t@pMTd', remotePath: '/'},
                pre:  {host: '10.200.22.1',            user: 'ftppenabcweb', remotePath: '/'},
                prod: {host: 'ftp.abc.srv.vocento.in', user: 'ftpnabcweb', remotePath: '/'}
            }
        })
    ];

    /**
     * Devuelve todos los medios disponibles
     *
     * @returns {Array}
     */
    this.getMedios = function () {
        return medios;
    };

    /**
     * Devuelte el medio por defecto
     *
     * @returns {Medio}
     */
    this.getDefaultMedio = function () {
        for (i in medios) {
            if (medios[i].isDefault()) {
                return medios[i];
            }
        }

        return null;
    };

    /**
     * Devuelve el medio seleccionado o el medio por defecto
     *
     * @returns {Medio}
     */
    this.getMedio = function (medio) {
        if (_.isUndefined(medio)) {
            return this.getDefaultMedio();
        } else {
            for (i in medios) {
                if (medios[i].id == medio) {
                    return medios[i];
                }
            }
        }

        return null;
    };
};

//module.exports = new VocMedios();
module.exports = VocMedio;